package main

import (
	"flow"
	"flow/registry"
	"log"
	"os"
	"strings"
)

func main() {

	r := registry.New()
	r.Add(strings.Split, strings.Join)

	f := flow.New()
	f.UseRegistry(r)

	first := f.Op("Join",
		f.Op("Split", "hello world", " "),
		"|",
	)

	// Find a way to process this
	v := f.Var("x", first)

	res, err := v.Process()
	log.Println("P:", res, err)

	opSplit := f.Op("Split", v, " ")
	opJoin := f.Op("Join", opSplit, ",")

	log.Println("Flow:", f)
	f.Analyse(os.Stdout)
	res, err = opJoin.Process()
	if err != nil {
		log.Fatal(err)
	}
	log.Println("res:", res)

}
